<?php
namespace Planejamento\Repositories;

class Restprod extends \Doctrine\ORM\EntityRepository
{

    public static function verificaRestricao($cdfilial, $cdproduto, $cdservfili){
        $sql = <<< SQL
   SELECT
   P.CDARVPROD
FROM
   RESTPROD R, PRODUTO P
WHERE
   (R.CDPRODUTO = P.CDPRODUTO) AND
   (R.CDFILIAL   = :P_CDFILIAL) AND
   (R.CDSERVFILI = :P_CDSERVICO) AND
   INSTR(P.CDARVPROD, :P_CDARVPROD) = 1

UNION

SELECT
   P.CDARVPROD
FROM
   RESTPROD R, PRODUTO P
WHERE
   (R.CDPRODUTO = P.CDPRODUTO) AND
   (R.CDFILIAL   = :P_CDFILIAL) AND
   (R.CDSERVFILI = :P_CDSERVICO) AND
   INSTR(P.CDARVPROD, :P_CDARVPROD) = 1
SQL;
        $params = array(
            'P_CDFILIAL' => $cdfilial,
            'P_CDARVPROD' =>$cdproduto,
            'P_CDSERVICO' => $cdservfili
        );

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function verificaLimitePercapita($cdfilial, $cdproduto, $cdservfili){
        $sql = <<< SQL
 SELECT
   COUNT(*)  AS NRPRODUTO
FROM
   LIMPEPRA L, PRODUTO P
WHERE
   (L.CDPRODUTO = P.CDPRODUTO) AND
   (L.CDFILIAL   = :P_CDFILIAL)      AND
   (L.CDSERVFILI = :P_CDSERVICO)     AND
   (INSTR(:P_CDARVPROD,P.CDARVPROD) = 1) AND
   (P.CDARVPROD  <=  :P_CDARVPROD)
SQL;
        $params = array(
            'P_CDFILIAL' => $cdfilial,
            'P_CDARVPROD' =>$cdproduto,
            'P_CDSERVICO' => $cdservfili

        );
        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }

    public static function verificaOcorrencia($cdfilial, $cdproduto, $cdservfili){
        $sql = <<< SQL
   SELECT
   R.CDFILIAL,
   R.CDSERVFILI,
   P.CDARVPROD
FROM
   RESTPROD R, PRODUTO P
WHERE
   (R.CDPRODUTO = P.CDPRODUTO) AND
   (R.CDFILIAL        = :P_CDFILIAL)     AND
   (R.CDSERVFILI   = :P_CDSERVFILI)   AND
   (:P_CDARVPROD LIKE P.CDARVPROD || '%' )
SQL;

        $params = array(
            'P_CDFILIAL' => $cdfilial,
            'P_CDARVPROD' =>$cdproduto,
            'P_CDSERVFILI' => $cdservfili

        );
        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
}