function Cmp06600_LogDeSolicitacaoDeCompras_Controller(General, ScreenService, localStorageEngine, ZhFilterPreferences, Utilities, MessageService) {
   
    this.setFilterInitValues = function(widget) {
	    const filterRow = {
            "CDFILIAL": getLocalVar('CDFILIAL'),
            "NMFILIALSOL": getLocalVar('NMFILIAL'),
            "PERIODO": {
                "start": moment().format('L'),
                "end": moment().format('L')
            },
            "NRORG": getLocalVar('NRORG')
	    };
	    
	    ZhFilterPreferences.setOriginalFilter(widget.id, filterRow);
    };
 
    this.widgetOnEnter = function(widget) {
        //widget.getField("NMFILIALSOL").filterProperties.readOnly = (window.projectCorp) ? false : true;
        
        const filialField = widget.getField("NMFILIALSOL");
        
        General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
            const filterRow = {
        	    PERIODO: {
        	        'formattedStart': moment().format('DD/MM/YYYY'),
        	        'formattedEnd': moment().format('DD/MM/YYYY'),
        	        'start': moment().format('DD/MM/YYYY'),
        	        'end': moment().format('DD/MM/YYYY')
        	    },
        	    CDFILIAL: getLocalVar("CDFILIAL"),
        	    NMFILIALSOL: getLocalVar("NMFILIAL")
            };
            
            if(response.dataset.data.CDFILCENTCMP == response.dataset.data.CDFILIAL) {
                var NMFILCENTCMP = response.dataset.data.NMFILCENTCMP;
                var CDFILCENTCMP = response.dataset.data.CDFILCENTCMP;
                filterRow.CDFILIAL = CDFILCENTCMP;
                filterRow.NMFILIALSOL = NMFILCENTCMP;
                filialField.filterProperties.readOnly = false;
                filialField.reload().then(function(success) {
                    let verificador = 0;
    	           success.dataset.filial_filioper_regiao.forEach(function(filial) {
    	               if(filial.CDFILIAL == filterRow.CDFILIAL) {
    	                   verificador++;
    	               }
    	           });
    	           if(verificador == 0) {
    	               delete filterRow.CDFILIAL;
    	               delete filterRow.NMFILIALSOL;
    	               filialField.reload();
    	           }
                });
            } else {
                filialField.filterProperties.readOnly = true;
                filialField.reload().then(function(success) {
    	           if(filialField.filterProperties.readOnly == true) {
    	               let verificador = 0;
    	               success.dataset.filial_filioper_regiao.forEach(function(filial) {
    	                   if(filial.CDFILIAL == filterRow.CDFILIAL) {
    	                       verificador++;
    	                   }
    	               });
    	               if(verificador == 0) {
    	                   filialField.filterProperties.validations.required = true;
    	                   MessageService.showMessageByCode("FILIAL_SEM_REGIAO", null, { type: 'ERROR' });
    	                   delete filterRow.CDFILIAL;
    	                   delete filterRow.NMFILIALSOL;
    	                   filialField.reload();
    	               } else {
    	                   delete filialField.filterProperties.validations.required;
    	                   filialField.reload();
    	               }
    	           }
    	       });
            }
            
            Utilities.startFilter(widget, filterRow);
            //widget.getField("NMFILIALSOL").reload();
        	//this.setFilterInitValues(widget);
        }, function(error) {
            MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
        });
    };

    this.filtrar = function(args) {
        const filterRow = args.e.preference.FILTER_ROW;
        
        if (typeof(filterRow) === 'object') {
            args.e.preference.CUSTOM_FILTER_ROW = {
                "P_DATAINIC": filterRow.PERIODO.start,
                "P_DATAFINA": filterRow.PERIODO.end,
                "P_CDOPERADOR": !Util.isEmptyOrBlank(filterRow.NMOPERADOR) ? filterRow.NMOPERADOR.join('_') : 'T',
                "P_CDFILIAL": filterRow.CDFILIAL,
                "NRORG": filterRow.NRORG,
                "P_CDOPERADORLOG": getLocalVar("CDOPERADOR")
            };
        }
    };
    
    this.setStripe = function(widget) {
        const filterRow = widget.appliedFilter.FILTER_ROW;
        const stripe = widget.container.getWidget('stripe');
        
    	stripe.getField('unidade').label = ScreenService.i18n('Unidade Solicitante: ') + filterRow.CDFILIAL + ' | ' + filterRow.NMFILIALSOL;
        stripe.getField('dataInicial').label = ScreenService.i18n('Data Inicial: ') + filterRow.PERIODO.start;
        stripe.getField('dataFinal').label = ScreenService.i18n('Data Final: ') + filterRow.PERIODO.end;
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp06600_LogDeSolicitacaoDeCompras_Controller', Cmp06600_LogDeSolicitacaoDeCompras_Controller);
});